<?php
// $Id: xml.class.php 930 2004-08-21 06:38:33Z stark $
//----------------------------------------------------------------------------
// Project : TOSTWebStats
// File    : xml.class.php
// Version : 0.1
// Author  : DiLDoG
//----------------------------------------------------------------------------

class xmlparser {
  /* Function will attempt to open the xmlloc as a local file, on fail it will attempt to open it as a web link */
  function open($xmlloc)
  {
    if (file_exists($xmlloc))
      $data = implode('', file($xmlloc));
    else {
      trigger_error ("Could not open XML File: $xmlloc", E_USER_WARNING);
      return false;
    }

    $parser = xml_parser_create('ISO-8859-1');
    xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
    xml_parse_into_struct($parser, $data, $vals, $index);
    xml_parser_free($parser);

    $i = 0;
    $content = Array();
    $content[strtolower($vals[$i]['tag'])][] = $this->GetChildren($vals, $i);
    return $content;
  }

  function GetChildren($vals, &$i)
  {
    $children = array();       // Contains node data

    /* Loop through children */
    while (++$i < count($vals))
    {
      switch ($vals[$i]['type'])
      {
        /* At end of current branch */
        case 'complete':
          if (isset($children[strtolower($vals[$i]['tag'])]))
          {
            // Create Array from s
            if (!is_array($children[strtolower($vals[$i]['tag'])]))
              $children[strtolower($vals[$i]['tag'])] = Array($children[strtolower($vals[$i]['tag'])], $vals[$i]['value']);
            else
              $children[strtolower($vals[$i]['tag'])][] = $vals[$i]['value'];
          }
          else
          {
            // Add a new child
            $children[strtolower($vals[$i]['tag'])] = @$vals[$i]['value'];
          }
          break;
        /* Node has more children */
        case 'open':
          if (isset($children[strtolower($vals[$i]['tag'])]))
          {
            // Create Array from s
            if (!isset($children[strtolower($vals[$i]['tag'])][0]))
              $children[strtolower($vals[$i]['tag'])] = Array($children[strtolower($vals[$i]['tag'])], $this->GetChildren($vals, $i));
            else
              $children[strtolower($vals[$i]['tag'])][] = $this->GetChildren($vals, $i);
          }
          else
          {
            // Add a new child
            $children[strtolower($vals[$i]['tag'])] = $this->GetChildren($vals, $i);
          }
          break;
        /* End of node, return collected data */
        case 'close':
            return $children;
      }
    }
  }
  
  function array_csort()
  {
    $args = func_get_args();
    $marray = array_shift($args);
    $i = 0;

    if (!is_array($marray) || count($marray) < 2)
      return $marray;

    $msortline = "array_multisort(";
    foreach ($args as $arg)
    {
      $i++;
      if (is_string($arg))
        foreach ($marray as $row) $sortarr[$i][] = $row[$arg];
      else
        $sortarr[$i] = $arg;
      $msortline .= "\$sortarr[".$i."],";
    }
    $msortline .= "\$marray);";

    eval($msortline);
    return $marray;
  }
}
?>