<?php
// $Id: index.php 974 2004-09-24 18:08:49Z stark $
//----------------------------------------------------------------------------
// Project : TOSTWebStats
// File    : index.php
// Version : 0.1
// Author  : [BB]Stark <stark@bbclan.de>
//----------------------------------------------------------------------------

// Report all errors except E_NOTICE
// (This is the default value set in php.ini)
error_reporting (E_ALL ^ E_NOTICE);

// Make sure the page will not be cached
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

// Load config file
require_once("./config.php");

// Load global functions
require_once("./inc/global.inc.php");

// Clear GET/POST variables and set them global
$cleaned = getSecVar();

// Extract vars. and prefix them with "gp"
extract($cleaned, EXTR_PREFIX_ALL, "gp");

// If no server-ID is given, check directories
if (!isset($gp_s))
{
	$tmp = Array();
	if (is_dir($cfg['Path']) && ($dh = opendir($cfg['Path'])))
	{
		while (($subdir = readdir($dh)) !== false)
			if ($subdir{0}!="." && !file_exists("./".$subdir."/hidden"))
				$tmp[] = $subdir;
		closedir($dh);
	}

	if (count($tmp)>1)
	{
		echo "Please choose a server:<br>\n";
		for ($i=0; $i < count($tmp); $i++)
			echo "<a href='".$_SERVER['PHP_SELF']."?s=".$tmp[$i]."'>".$tmp[$i]."</a><br>\n";
	}
	else if (count($tmp)==1)
		header("Location: ".$_SERVER['PHP_SELF']."?s=".$tmp[0]);
	else
		echo "No stats received yet!";

	exit();
}

// Load XML parser and report parser classes
require_once("./classes/xml.class.php");
require_once("./classes/report.class.php");

// Abort if the server-ID is unknown
if (!($clientconfig = FindClient($gp_s)))
	exit();

// Create xml-filename
$file = $cfg['Path'].$clientconfig['id']."/".basename($gp_id).".xml";
$map = "";
$mode = "browse";

// Output if file exists...
if (file_exists($file))
{
	$map = new matchreport($file);
	$mode = isset($gp_mode) ? $gp_mode : "result";
}

$layout = 1;
if (isset($gp_layout))
{
  setcookie("layout", $gp_layout, time()+60*60*30*365);
  $layout = $gp_layout;
}
else if (!empty($_COOKIE['layout']))
  $layout = $_COOKIE['layout'];

//print_r($cleaned);

include("./inc/xheader.inc.php");

// include active page:
for ($i=0; $i<count($cfg['page']); $i++)
{
	if ($cfg['page'][$i]['key']==$mode)
	{
		include("./inc/".$cfg['page'][$i]['file']);
		break;
	}
}

include("./inc/xfooter.inc.php");

// EOF
?>
